package com.its.api.its.service.vms;

import com.its.api.its.model.dto.vms.TbVmsIfscRltnDto;
import com.its.api.its.model.entity.vms.TbVmsIfscRltn;
import com.its.api.its.model.entity.vms.TbVmsIfscRltnKey;
import com.its.api.its.repository.vms.TbVmsIfscRltnRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbVmsIfscRltnService {

    private final TbVmsIfscRltnRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbVmsIfscRltn requireOne(TbVmsIfscRltnKey id) {
        return repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    public List<TbVmsIfscRltnDto> findAll() {
        List<TbVmsIfscRltnDto> result = new ArrayList<>();
        List<TbVmsIfscRltn> data = this.repo.findAll();
        for (TbVmsIfscRltn entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    public TbVmsIfscRltnDto findById(TbVmsIfscRltnKey id) {
        TbVmsIfscRltn entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    /*public TbVmsIfscRltnDto updateById(TbVmsIfscRltnKey id, TbVmsIfscRltnDto.TbVmsIfscRltnUpdReq req) {
        TbVmsIfscRltn entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }*/

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    /*public List<TbVmsIfscRltnDto> mergeInfoList(List<TbVmsIfscRltnDto.TbVmsIfscRltnUpdReq> reqList) {
        List<TbVmsIfscRltnDto> result = new ArrayList<>();
        for (TbVmsIfscRltnDto.TbVmsIfscRltnUpdReq req : reqList) {
            TbVmsIfscRltn obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }*/

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbVmsIfscRltnDto.TbVmsIfscRltnUpdReq mergeInfo(TbVmsIfscRltnDto.TbVmsIfscRltnUpdReq req) {

        // 기존 설정 정보를 삭제한다.
        this.repo.deleteDataById(req.getVmsCtlrNmbr());

        // 설정 정보를 저장한다.
        List<TbVmsIfscRltn> data = req.toEntity();
        for (TbVmsIfscRltn obj : data) {
            this.repo.save(obj);
        }
        return req;
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    /*public TbVmsIfscRltnDto deleteById(TbVmsIfscRltnKey id) {
        TbVmsIfscRltn entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }*/

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    /*public List<TbVmsIfscRltnDto> deleteByIds(List<TbVmsIfscRltnKey> ids) {
        List<TbVmsIfscRltnDto> result = new ArrayList<>();
        for (TbVmsIfscRltnKey id : ids) {
            Optional<TbVmsIfscRltn> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }*/

    // 도형식 VMS 에 설정된 정보제공 구간 목록 전체를 리턴
    public List<TbVmsIfscRltnDto> findFigureIfscAll() {
        List<TbVmsIfscRltnDto> result = new ArrayList<>();
        List<TbVmsIfscRltn> list = this.repo.findDataAll();
        for (TbVmsIfscRltn obj : list) {
            if (obj.getIfsc() != null && obj.getVms() != null && ("VMP1").equals(obj.getVms().getVmsTypeCd())) {
                if (!("Y").equals(obj.getVms().getDelYn()) && !("EDI2").equals(obj.getIfsc().getEdtnCd())) {
                    // 삭제 된것 제외
                    result.add(obj.toDto());
                }
            }
        }
        return result;
    }

    public List<TbVmsIfscRltnDto> findDataById(Long vmsCtlrNmbr) {
        List<TbVmsIfscRltnDto> result = new ArrayList<>();
        List<TbVmsIfscRltn> list = this.repo.findDataById(vmsCtlrNmbr);
        for (TbVmsIfscRltn obj : list) {
            if (obj.getIfsc() != null && obj.getVms() != null) {
                if (!("Y").equals(obj.getVms().getDelYn()) && !("EDI2").equals(obj.getIfsc().getEdtnCd())) {
                    // 삭제 된것 제외
                    result.add(obj.toDto());
                }
            }
        }
        return result;
    }

    // VMS_IFSC_ID 사용 중인 갯수 리턴
    public int findUsageCountByVmsIfscId(Long vmsIfscId ) {
        return this.repo.findUsageCountByVmsIfscId(vmsIfscId);
    }
}

